/*
 *  rcall4.c
 *
 *  Implements a generic wrapper for ROM routines with four parameters.
 *
 *  The contents of this file are subject to the Mozilla Public License
 *  Version 1.0 (the "License"); you may not use this file except in
 *  compliance with the License. You may obtain a copy of the License at
 *  http://www.mozilla.org/MPL/
 *
 *  Software distributed under the License is distributed on an "AS IS"
 *  basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 *  License for the specific language governing rights and limitations
 *  under the License.
 *
 *  The Original Code is Librcx code, released February 9, 1999.
 *
 *  The Initial Developer of the Original Code is Kekoa Proudfoot.
 *  Portions created by Kekoa Proudfoot are Copyright (C) 1999
 *  Kekoa Proudfoot. All Rights Reserved.
 *
 *  Contributor(s): Kekoa Proudfoot <kekoa@graphics.stanford.edu>
 */

__asm__ (
    ".section .text\n\t",
    ".global ___rcall4\n"
    "___rcall4:\n\t"
    "push r6\n\t"
    "mov.w @(0x6,r7),r3\n\t"
    "push r3\n\t"
    "mov.w @(0x6,r7),r3\n\t"
    "push r3\n\t"
    "push r2\n\t"
    "mov.w r1,r6\n\t"
    "jsr @r0\n\t"
    "mov.w r6,r0\n\t"
    "add.b #0x6,r7l\n\t"
    "addx #0x0,r7h\n\t"
    "pop r6\n\t"
    "rts"
);

#if 0
short
__rcall4 (short a, short p0, short p1, short p2, short p3)
{
    __asm__ (
	"push %5\n\t"
	"push %4\n\t"
	"push %3\n\t"
	"mov.w %2,r6\n\t"
	"jsr @%0\n\t"
	"mov.w r6,%0\n\t"
	"adds #0x2,r7\n\t"
	"adds #0x2,r7\n\t"
	"adds #0x2,r7"
	: "=r" (a)
	: "0" (a), "g" (p0), "r" (p1), "r" (p2), "r" (p3)
	: "r6", "r7", "cc", "memory"
	);
    return a;
}
#endif
